<template>
  <div
    class="ui fluid dropdown search selection multiple"
    :id="id"
    style="margin-top: 5px"
  >
    <input
      class="search"
      autocomplete="off"
      tabindex="0"
    >
    <i class="dropdown icon"></i>
    <div class="default text">Régimes</div>

    <div class="menu">
      <div
        class="item"
        v-for="diet in dietsAvailable"
        :key="diet._id"
        :data-value="diet._id"
      >
        {{ diet.name }}
      </div>
    </div>

  </div>
</template>

<script>
import { mapGetters } from 'vuex'

import store from '@/store/Store'
import DietsStore from '@/store/modules/diets/DietsStore'

export default {
  name: 'DropdownDiets',
  store,
  props: {
    initialDiets: Array
  },
  data () {
    return {
      id: 'dropdown' + Math.floor(Math.random() * 10000000)
    }
  },
  beforeCreate () {
    if (DietsStore.getters.count(DietsStore.state) === 0) {
      store.dispatch('DietsStore/loadDiets')
        .then(
          (response) => {
            this.initDropdown()
          },
          (error) => {
            this.$toastr.e(error.response.data.message)
          }
        )
    }
  },
  mounted () {
    this.initDropdown()
  },
  methods: {
    initDropdown () {
      var self = this

      // eslint-disable-next-line
      $('#' + this.id)
        .dropdown('set selected', this.initialDiets)
      // eslint-disable-next-line
      $('#' + this.id)
        .dropdown({
          onChange (value, text, $selectedItem) {
            self.$emit('dietsChanged', value)
          }
        })
    },
    itemDeleted () {
      // eslint-disable-next-line
      $('#' + this.id)
        .trigger('change')
    }
  },
  computed: {
    ...mapGetters({
      dietsAvailable: 'DietsStore/diets'
    })
  }
}
</script>
